diff --git a/libpurple/protocols/null/nullprpl.c b/libpurple/protocols/null/nullprpl.c
--- a/libpurple/protocols/null/nullprpl.c
+++ b/libpurple/protocols/null/nullprpl.c
@@ -458,7 +458,10 @@
    return 1;
 }
 
-static void null_set_info(PurpleConnection *gc, const char *info) {
+static void
+null_set_info(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+              const gchar *info)
+{
   purple_debug_info("nullprpl", "setting %s's user info to %s\n",
                     purple_account_get_username(purple_connection_get_account(gc)), info);
 }
@@ -496,7 +499,10 @@
   return 0;
 }
 
-static void null_get_info(PurpleConnection *gc, const char *username) {
+static void
+null_get_info(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+              const gchar *username)
+{
   const char *body;
   PurpleNotifyUserInfo *info = purple_notify_user_info_new();
   PurpleAccount *acct;
@@ -529,7 +535,10 @@
                          NULL);     /* userdata for callback */
 }
 
-static void null_set_status(PurpleAccount *acct, PurpleStatus *status) {
+static void
+null_set_status(PurpleProtocolServer *protocol_server, PurpleAccount *acct,
+                PurpleStatus *status)
+{
   const char *msg = purple_status_get_attr_string(status, "message");
   purple_debug_info("nullprpl", "setting %s's status to %s: %s\n",
                     purple_account_get_username(acct), purple_status_get_name(status), msg);
@@ -538,20 +547,26 @@
                       NULL);
 }
 
-static void null_set_idle(PurpleConnection *gc, int idletime) {
+static void
+null_set_idle(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+              gint idletime)
+{
   purple_debug_info("nullprpl",
                     "purple reports that %s has been idle for %d seconds\n",
                     purple_account_get_username(purple_connection_get_account(gc)), idletime);
 }
 
-static void null_change_passwd(PurpleConnection *gc, const char *old_pass,
-                                   const char *new_pass) {
+static void
+null_change_passwd(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                   const gchar *old_pass, const gchar *new_pass)
+{
   purple_debug_info("nullprpl", "%s wants to change their password\n",
                     purple_account_get_username(purple_connection_get_account(gc)));
 }
 
-static void null_add_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
-                               PurpleGroup *group, const char *message)
+static void
+null_add_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+               PurpleBuddy *buddy, PurpleGroup *group, const gchar *message)
 {
   const char *username = purple_account_get_username(purple_connection_get_account(gc));
   PurpleConnection *buddy_gc = get_null_gc(purple_buddy_get_name(buddy));
@@ -579,38 +594,44 @@
   }
 }
 
-static void null_add_buddies(PurpleConnection *gc, GList *buddies,
-                                 GList *groups, const char *message) {
+static void
+null_add_buddies(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                 GList *buddies, GList *groups, const gchar *message)
+{
   GList *buddy = buddies;
   GList *group = groups;
 
   purple_debug_info("nullprpl", "adding multiple buddies\n");
 
   while (buddy && group) {
-    null_add_buddy(gc, (PurpleBuddy *)buddy->data, (PurpleGroup *)group->data, message);
+    null_add_buddy(protocol_server, gc, PURPLE_BUDDY(buddy->data),
+                   PURPLE_GROUP(group->data), message);
     buddy = g_list_next(buddy);
     group = g_list_next(group);
   }
 }
 
-static void null_remove_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
-                                  PurpleGroup *group)
+static void
+null_remove_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                  PurpleBuddy *buddy, PurpleGroup *group)
 {
   purple_debug_info("nullprpl", "removing %s from %s's buddy list\n",
                     purple_buddy_get_name(buddy),
                     purple_account_get_username(purple_connection_get_account(gc)));
 }
 
-static void null_remove_buddies(PurpleConnection *gc, GList *buddies,
-                                    GList *groups) {
+static void
+null_remove_buddies(PurpleProtocolServer *protocol_server,
+                    PurpleConnection *gc, GList *buddies, GList *groups)
+{
   GList *buddy = buddies;
   GList *group = groups;
 
   purple_debug_info("nullprpl", "removing multiple buddies\n");
 
   while (buddy && group) {
-    null_remove_buddy(gc, (PurpleBuddy *)buddy->data,
-                          (PurpleGroup *)group->data);
+    null_remove_buddy(protocol_server, gc, PURPLE_BUDDY(buddy->data),
+                      PURPLE_GROUP(group->data));
     buddy = g_list_next(buddy);
     group = g_list_next(group);
   }
@@ -833,26 +854,35 @@
   }
 }
 
-static void null_register_user(PurpleAccount *acct) {
+static void
+null_register_user(PurpleProtocolServer *protocol_server, PurpleAccount *acct) {
  purple_debug_info("nullprpl", "registering account for %s\n",
                    purple_account_get_username(acct));
 }
 
-static void null_alias_buddy(PurpleConnection *gc, const char *who,
-                                 const char *alias) {
+static void
+null_alias_buddy(PurpleProtocolServer *protocol_server,
+                 PurpleConnection *gc, const gchar *who,
+                 const gchar *alias)
+{
  purple_debug_info("nullprpl", "%s sets %s's alias to %s\n",
                    purple_account_get_username(purple_connection_get_account(gc)), who, alias);
 }
 
-static void null_group_buddy(PurpleConnection *gc, const char *who,
-                                 const char *old_group,
-                                 const char *new_group) {
+static void
+null_group_buddy(PurpleProtocolServer *protocol_server,
+                 PurpleConnection *gc, const gchar *who,
+                 const gchar *old_group, const gchar *new_group)
+{
   purple_debug_info("nullprpl", "%s has moved %s from group %s to group %s\n",
                     purple_account_get_username(purple_connection_get_account(gc)), who, old_group, new_group);
 }
 
-static void null_rename_group(PurpleConnection *gc, const char *old_name,
-                                  PurpleGroup *group, GList *moved_buddies) {
+static void
+null_rename_group(PurpleProtocolServer *protocol_server,
+                  PurpleConnection *gc, const gchar *old_name,
+                  PurpleGroup *group, GList *moved_buddies)
+{
   purple_debug_info("nullprpl", "%s has renamed group %s to %s\n",
                     purple_account_get_username(purple_connection_get_account(gc)), old_name,
                     purple_group_get_name(group));
@@ -876,14 +906,19 @@
   return input;
 }
 
-static void null_set_buddy_icon(PurpleConnection *gc,
-                                    PurpleImage *img) {
+static void
+null_set_buddy_icon(PurpleProtocolServer *protocol_server,
+                    PurpleConnection *gc, PurpleImage *img)
+{
  purple_debug_info("nullprpl", "setting %s's buddy icon to %s\n",
                    purple_account_get_username(purple_connection_get_account(gc)),
                    img ? purple_image_get_path(img) : "(null)");
 }
 
-static void null_remove_group(PurpleConnection *gc, PurpleGroup *group) {
+static void
+null_remove_group(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                  PurpleGroup *group)
+{
   purple_debug_info("nullprpl", "%s has removed group %s\n",
                     purple_account_get_username(purple_connection_get_account(gc)),
                     purple_group_get_name(group));
diff --git a/libpurple/protocols/sametime/sametime.c b/libpurple/protocols/sametime/sametime.c
--- a/libpurple/protocols/sametime/sametime.c
+++ b/libpurple/protocols/sametime/sametime.c
@@ -1424,7 +1424,7 @@
 }
 
 
-static void mw_protocol_set_status(PurpleAccount *acct, PurpleStatus *status);
+static void mw_protocol_set_status(PurpleProtocolServer *protocol_server, PurpleAccount *acct, PurpleStatus *status);
 
 
 /** called from mw_session_stateChange when the session's state is
@@ -1437,7 +1437,7 @@
   /* set out initial status */
   acct = purple_connection_get_account(pd->gc);
   status = purple_account_get_active_status(acct);
-  mw_protocol_set_status(acct, status);
+  mw_protocol_set_status(NULL, acct, status);
 
   /* start watching for new conversations */
   purple_signal_connect(purple_conversations_get_handle(),
@@ -3824,8 +3824,10 @@
 }
 
 
-static void mw_protocol_get_info(PurpleConnection *gc, const char *who) {
-
+static void
+mw_protocol_get_info(PurpleProtocolServer *protocol_server,
+                     PurpleConnection *gc, const gchar *who)
+{
   struct mwAwareIdBlock idb = { mwAware_USER, (char *) who, NULL };
 
   struct mwPurpleProtocolData *pd;
@@ -3898,7 +3900,10 @@
 }
 
 
-static void mw_protocol_set_status(PurpleAccount *acct, PurpleStatus *status) {
+static void
+mw_protocol_set_status(PurpleProtocolServer *protocol_server,
+                       PurpleAccount *acct, PurpleStatus *status)
+{
   PurpleConnection *gc;
   const char *state;
   char *message = NULL;
@@ -3951,7 +3956,10 @@
 }
 
 
-static void mw_protocol_set_idle(PurpleConnection *gc, int t) {
+static void
+mw_protocol_set_idle(PurpleProtocolServer *protocol_server,
+                     PurpleConnection *gc, gint t)
+{
   struct mwSession *session;
   struct mwUserStatus stat;
 
@@ -4125,11 +4133,11 @@
 }
 
 
-static void mw_protocol_add_buddy(PurpleConnection *gc,
-			      PurpleBuddy *buddy,
-			      PurpleGroup *group,
-			      const char *message) {
-
+static void
+mw_protocol_add_buddy(PurpleProtocolServer *protocol_server,
+                      PurpleConnection *gc, PurpleBuddy *buddy,
+                      PurpleGroup *group, const gchar *message)
+{
   struct mwPurpleProtocolData *pd = purple_connection_get_protocol_data(gc);
   struct mwServiceResolve *srvc;
   GList *query;
@@ -4173,7 +4181,9 @@
 }
 
 
-static void mw_protocol_add_buddies(PurpleConnection *gc,
+static void
+mw_protocol_add_buddies(PurpleProtocolServer *protocol_server,
+                        PurpleConnection *gc,
 				GList *buddies,
 				GList *groups,
 				const char *message) {
@@ -4224,9 +4234,11 @@
 }
 
 
-static void mw_protocol_remove_buddy(PurpleConnection *gc,
-				 PurpleBuddy *buddy, PurpleGroup *group) {
-
+static void
+mw_protocol_remove_buddy(PurpleProtocolServer *protocol_server,
+                         PurpleConnection *gc, PurpleBuddy *buddy,
+                         PurpleGroup *group)
+{
   struct mwPurpleProtocolData *pd;
   struct mwAwareIdBlock idb = { mwAware_USER, (char *)purple_buddy_get_name(buddy), NULL };
   struct mwAwareList *list;
@@ -4527,7 +4539,10 @@
 }
 
 
-static void mw_protocol_keepalive(PurpleConnection *gc) {
+static void
+mw_protocol_keepalive(PurpleProtocolServer *protocol_server,
+                      PurpleConnection *gc)
+{
   struct mwSession *session;
 
   g_return_if_fail(gc != NULL);
@@ -4539,10 +4554,11 @@
 }
 
 
-static void mw_protocol_alias_buddy(PurpleConnection *gc,
-				const char *who,
-				const char *alias) {
-
+static void
+mw_protocol_alias_buddy(PurpleProtocolServer *protocol_server,
+                        PurpleConnection *gc, const gchar *who,
+                        const gchar *alias)
+{
   struct mwPurpleProtocolData *pd = purple_connection_get_protocol_data(gc);
   g_return_if_fail(pd != NULL);
 
@@ -4553,11 +4569,11 @@
 }
 
 
-static void mw_protocol_group_buddy(PurpleConnection *gc,
-				const char *who,
-				const char *old_group,
-				const char *new_group) {
-
+static void
+mw_protocol_group_buddy(PurpleProtocolServer *protocol_server,
+                        PurpleConnection *gc, const gchar *who,
+                        const gchar *old_group, const gchar *new_group)
+{
   struct mwAwareIdBlock idb = { mwAware_USER, (char *) who, NULL };
   GList *gl = g_list_prepend(NULL, &idb);
 
@@ -4582,11 +4598,11 @@
 }
 
 
-static void mw_protocol_rename_group(PurpleConnection *gc,
-				 const char *old,
-				 PurpleGroup *group,
-				 GList *buddies) {
-
+static void
+mw_protocol_rename_group(PurpleProtocolServer *protocol_server,
+                         PurpleConnection *gc, const gchar *old,
+                         PurpleGroup *group, GList *buddies)
+{
   struct mwPurpleProtocolData *pd = purple_connection_get_protocol_data(gc);
   g_return_if_fail(pd != NULL);
 
@@ -4644,7 +4660,10 @@
 }
 
 
-static void mw_protocol_remove_group(PurpleConnection *gc, PurpleGroup *group) {
+static void
+mw_protocol_remove_group(PurpleProtocolServer *protocol_server,
+                         PurpleConnection *gc, PurpleGroup *group)
+{
   struct mwPurpleProtocolData *pd;
   struct mwAwareList *list;
 
diff --git a/libpurple/protocols/zephyr/zephyr.c b/libpurple/protocols/zephyr/zephyr.c
--- a/libpurple/protocols/zephyr/zephyr.c
+++ b/libpurple/protocols/zephyr/zephyr.c
@@ -1867,7 +1867,9 @@
 	return buf;
 }
 
-static void zephyr_zloc(PurpleConnection *gc, const char *who)
+static void
+zephyr_zloc(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+            const gchar *who)
 {
 	zephyr_account *zephyr = purple_connection_get_protocol_data(gc);
 	gchar* normalized_who = local_zephyr_normalize(zephyr,who);
@@ -1894,7 +1896,10 @@
 	}
 }
 
-static void zephyr_set_status(PurpleAccount *account, PurpleStatus *status) {
+static void
+zephyr_set_status(PurpleProtocolServer *protocol_server,
+                  PurpleAccount *account, PurpleStatus *status)
+{
 	PurpleConnection *gc = purple_account_get_connection(account);
 	zephyr_account *zephyr = purple_connection_get_protocol_data(gc);
 	PurpleStatusPrimitive primitive = purple_status_type_get_primitive(purple_status_get_status_type(status));
@@ -2230,7 +2235,7 @@
 static PurpleCmdRet zephyr_purple_cmd_zlocate(PurpleConversation *conv,
 					  const char *cmd, char **args, char **error, void *data)
 {
-	zephyr_zloc(purple_conversation_get_connection(conv),args[0]);
+	zephyr_zloc(NULL, purple_conversation_get_connection(conv),args[0]);
 	return PURPLE_CMD_RET_OK;
 }
 
diff --git a/libpurple/purpleaccountpresence.c b/libpurple/purpleaccountpresence.c
--- a/libpurple/purpleaccountpresence.c
+++ b/libpurple/purpleaccountpresence.c
@@ -23,6 +23,8 @@
 
 #include "purpleaccountpresence.h"
 
+#include "purpleprotocolserver.h"
+
 struct _PurpleAccountPresence {
 	PurplePresence parent;
 
@@ -94,8 +96,8 @@
 		protocol = purple_connection_get_protocol(gc);
 	}
 
-	if(protocol) {
-		purple_protocol_server_iface_set_idle(protocol, gc, (idle ? (current_time - idle_time) : 0));
+	if(PURPLE_IS_PROTOCOL_SERVER(protocol)) {
+		purple_protocol_server_set_idle(PURPLE_PROTOCOL_SERVER(protocol), gc, (idle ? (current_time - idle_time) : 0));
 	}
 }
 
